'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;
// import { createSelector  } from 'reselect'


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _reactBootstrap = require('react-bootstrap');

var _reactFontawesome = require('react-fontawesome');

var _reactFontawesome2 = _interopRequireDefault(_reactFontawesome);

var _tools = require('views/utils/tools');

var _countdownTimer = require('views/components/main/parts/countdown-timer');

var _functions = require('./functions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// const constShipsSelector = createSelector(
//   constSelector,
//   (_const) => _.keyBy(_const.$ships, 'api_id')
// )

const { ROOT, i18n } = window;
const __ = i18n['poi-plugin-anchorage-repair'].__.bind(i18n['poi-plugin-anchorage-repair']);

const ShipRow = (0, _reactRedux.connect)(state => {
  const canNotify = state.misc.canNotify;
  return {
    canNotify
  };
})((_temp = _class = class ShipRowClass extends _react.Component {

  render() {
    const { timeElapsed, lastRefresh, canRepair, ship, canNotify } = this.props;
    const { api_nowhp, api_maxhp, availableSRF, estimate, timePerHP,
      api_id, api_lv, inRepair, api_name } = ship;
    const completeTime = lastRefresh + estimate;

    return _react2.default.createElement(
      'tr',
      null,
      _react2.default.createElement(
        'td',
        null,
        i18n.resources.__(api_name),
        _react2.default.createElement(
          'span',
          { className: 'lv-label' },
          'Lv.',
          api_lv
        )
      ),
      _react2.default.createElement(
        'td',
        null,
        _react2.default.createElement(
          _reactBootstrap.Label,
          { bsStyle: (0, _functions.getHPLabelStyle)(api_nowhp, api_maxhp, availableSRF, inRepair) },
          `${api_nowhp} / ${api_maxhp}`
        )
      ),
      _react2.default.createElement(
        'td',
        null,
        estimate > 0 && canRepair && availableSRF && (!inRepair ? _react2.default.createElement(_countdownTimer.CountdownNotifierLabel, {
          timerKey: `anchorage-ship-${api_id}`,
          completeTime: completeTime,
          getLabelStyle: _functions.getCountdownLabelStyle,
          getNotifyOptions: () => canNotify && lastRefresh > 0 && _extends({}, this.constructor.basicNotifyConfig, {
            completeTime,
            args: i18n.resources.__(api_name)
          })
        }) : inRepair ? _react2.default.createElement(
          _reactBootstrap.Label,
          { bsStyle: 'success' },
          _react2.default.createElement(_reactFontawesome2.default, { name: 'wrench' }),
          ' ',
          __('Docking')
        ) : '')
      ),
      _react2.default.createElement(
        'td',
        null,
        timePerHP ? (0, _tools.resolveTime)(timePerHP / 1000) : ''
      ),
      _react2.default.createElement(
        'td',
        null,
        canRepair && api_nowhp !== api_maxhp && !inRepair && (0, _functions.repairEstimate)(ship, timeElapsed, availableSRF)
      )
    );
  }
}, _class.basicNotifyConfig = {
  type: 'repair',
  title: __('Anchorage repair'),
  message: names => `${_lodash2.default.join(names, ', ')} ${__('anchorage repair completed')}`,
  icon: (0, _path.join)(ROOT, 'assets', 'img', 'operation', 'repair.png'),
  preemptTime: 0,
  groupKey: 'plugin-anchorage-repair'
}, _class.propTypes = {
  canNotify: _react.PropTypes.bool.isRequired,
  timeElapsed: _react.PropTypes.number.isRequired,
  lastRefresh: _react.PropTypes.number.isRequired,
  ship: _react.PropTypes.object.isRequired,
  canRepair: _react.PropTypes.bool.isRequired
}, _temp));

exports.default = ShipRow;
module.exports = exports['default'];